﻿Imports System.ComponentModel
Imports System.Windows.Forms
Imports Haushaltsbuch.dtsHaushaltsbuch

Public Class frmHaushaltsbuch

	Public Sub New()
		InitializeComponent()
		If NotifyPropertyChanged.IsInDesignMode Then Return
		ControlStyling.StyleControls(Me)
		Dts.DataFile("..\..\DataStuff\dtsHaushaltsbuch.xml").Register(Me).Fill
		AutoMenu.Create(AddressOf InitData, AddressOf SaveData, AddressOf BerechneSalden)
	End Sub

	Private Sub InitData()
		Dim rnd = New Random(44)
		Dim rndNxt = Function() CDec(rnd.Next(0, 100000) / 100)
		For i = 0 To 5
			Dim mnt = Dts.BuchungsMonat.AddBuchungsMonatRow($"Monat{i}", 0D, 0D, $"Bezeichnung{i}")
			Dim dtMnt = New Date(2021, i + 1, 1)
			For ii = 0 To 8
				Dim buchg = Dts.Buchung.AddBuchungRow((i * 6 + ii).ToString, rndNxt(), rndNxt(), 0, 0, $"Text{i}_{ii}", dtMnt.AddDays(ii), mnt)
			Next
		Next
	End Sub

	Private Sub SaveData()
		Dts.Save(Me)
	End Sub

	Const _InvalidRows As DataRowState = DataRowState.Deleted Or DataRowState.Detached

	Private Sub BerechneBuchungen()
		Dim anfangssaldo = 50D ' oder my.settings
		Dim buchungen = Aggregate rw In Dts.Buchung Where 0 = (rw.RowState And _InvalidRows) Order By rw.Datum Into ToList
		Dim rwVorher = buchungen(0)
		rwVorher.BestandVorher = anfangssaldo
		rwVorher.Bestand = anfangssaldo + rwVorher.Einnahmen - rwVorher.Ausgaben
		For i = 1 To buchungen.Count - 1
			Dim row = buchungen(i)
			row.BestandVorher = rwVorher.Bestand
			row.Bestand = row.BestandVorher + row.Einnahmen - row.Ausgaben
			rwVorher = row
		Next
	End Sub

	Private Sub BerechneSalden()
		BerechneBuchungen()
		BerechneMonatsbuchungen()
	End Sub
	Private Sub BerechneMonatsbuchungen()
		For Each rwMonat In Dts.BuchungsMonat.Where(Function(x) 0 = (x.RowState And _InvalidRows))
			Dim buchungen = rwMonat.GetBuchungRows
			If buchungen.Length = 0 Then Continue For
			rwMonat.Anfangssaldo = buchungen(0).BestandVorher
			rwMonat.Endsaldo = buchungen.Last.Bestand
		Next
	End Sub
	'Private Sub BerechneBuchungen()
	'	Dim anfangssaldo = 50D ' oder my.settings
	'	Dim rwVorher = DirectCast(DirectCast(bsBuchMonat_Buchung(0), DataRowView).Row, BuchungRow)
	'	rwVorher.BestandVorher = anfangssaldo
	'	rwVorher.Bestand = anfangssaldo + rwVorher.Einnahmen - rwVorher.Ausgaben
	'	For i = 1 To bsBuchMonat_Buchung.Count - 1
	'		Dim row = DirectCast(DirectCast(bsBuchMonat_Buchung(i), DataRowView).Row, BuchungRow)
	'		row.BestandVorher = rwVorher.Bestand
	'		row.Bestand = row.BestandVorher + row.Einnahmen - row.Ausgaben
	'		rwVorher = row
	'	Next
	'End Sub

End Class